#include <linux/soundcard.h>
#include <fcntl.h>
#include <mikmod.h>
#include "vorbis/codec.h"
#include "vorbis/vorbisfile.h"
#include "main.h"
#include "init.h"

int t_ioctl(int arg1, int val)
{
	return ioctl(fd_dsp, arg1, &val);
}

/* load TAH pr0n */
void load_textures()
{
	load_tex("gfx/thought.png", 0);
	load_tex("gfx/code.png", 1);
	load_tex("gfx/music.png", 2);
	load_tex("gfx/tunn.png", 3);
	load_tex("gfx/wall.png", 4);
	load_tex("gfx/border.png", 5);
	load_tex("gfx/walls.png", 6);
	load_tex("gfx/floor.png", 7);
	load_tex("gfx/sky.png", 8);
	load_tex("gfx/bg3.png", 9);
	load_tex("gfx/particle.png", 10);
	load_tex("gfx/scroller_utkast5.png", 11);
	load_tex("gfx/title-claus-down.png", 12);
	load_tex("gfx/title-sting-down.png", 13);
	load_tex("gfx/music_agoz.png", 14);
	load_tex("gfx/code_agoz.png", 15);
	load_tex("gfx/mountian.png", 16);
	load_tex("gfx/rand3.png", 17);
	load_tex("gfx/face.png", 18);
	load_tex("gfx/structure.png", 19);
	load_tex("gfx/greets.png", 20);
	load_tex("gfx/eof.png", 21);
}

int ogg_quit()
{
	ov_clear(&vf);
	printf("Done playing music.\n");
	return 0;
}

void init(void)
{
	glFogi(GL_FOG_MODE, fogmode[fogfilter]);
	glFogfv(GL_FOG_COLOR, fogcolor);
	glFogf(GL_FOG_DENSITY, 0.15f);
	glHint(GL_FOG_HINT, GL_DONT_CARE);
	glFogf(GL_FOG_START, 11.0f);
	glFogf(GL_FOG_END, 10.0f);
	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glLightfv(GL_LIGHT0, GL_AMBIENT, light1_ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light1_diffuse);
	glLightfv(GL_LIGHT0, GL_POSITION, light1_position);
	/*
	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, low_shininess);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
	*/
}

/* mp3? No! Ogg vorbis is the way to go */
void ogg_play()
{
	vorbis_info *info;
	if((file = fopen("music.ogg", "rb")) == NULL) {
		printf("Could not open file\n");
		exit(1);
	}
	if(ov_open(file, &vf, NULL, 0) < 0) {
		printf("Not a valid ogg file\n");
		exit(1);
	}
	fd_dsp = open("/dev/dsp", O_WRONLY, 0);
	/*	t_ioctl(SNDCTL_DSP_RESET, 1);*/
	t_ioctl(SOUND_PCM_WRITE_RATE, 44100);
	t_ioctl(SOUND_PCM_WRITE_CHANNELS, 2);
	t_ioctl(SNDCTL_DSP_SETFMT, AFMT_S16_LE);
	/*	t_ioctl(SNDCTL_DSP_NONBLOCK, 0);*/
	/*	t_ioctl(SNDCTL_DSP_SETFRAGMENT, 0x7fff000c);*/
	while(ret != 0) {
		ret = ov_read(&vf, buf, sizeof(buf), 0, 2, 1, &current_sec);
		if((write(fd_dsp, buf, ret)) == -1) {
			printf("Could not write do /dev/dsp! Already in use?\n");
			exit(1);
		}
		if(ret==0) {
			ogg_quit();
		}
	}
}

