#include "main.h"
#include "onlymain.h"
#include "termoskube.h"

void display(void)
{

	if(rut/333 > 0 && rut/333 < 18.2) {
		scene1();
	}

	if(rut/333 > 18.2 && rut/333 < 32.8) {
		scene2();
	}

	if(rut/333 > 32.8 && rut/333 < 47.5) {
		scene5();
	}

	if(rut/333 > 47.5 && rut/333 < 73.0) {
		scene6();
	}

	if(rut/333 > 73.0 && rut/333 < 173) {
		glColor3f(1.0, 1.0, 1.0);
		scene4();
		glEnable(GL_TEXTURE_2D);
		glLoadIdentity();
		glTranslatef(0.0, 0.0, -10.0);
		BINDTEX(17);
		glColor3f(0.7, 0.7, 0.7);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-9.3, 7.0, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 9.3, 7.0, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 9.3,-7.0, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-9.3,-7.0, 0.0);
		glEnd();		
	}

	if(rut/333 > 173 && rut/333 < 215.5) {
		scene7();
	}

	if(rut/333 > 215.5 && rut/333 < 280.0) {
		float mov, mov1;
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glEnable(GL_TEXTURE_2D);
		glLoadIdentity();
		glTranslatef(0.0, 0.0, -10.0);
		BINDTEX(18);
		glColor3f(0.7, 0.7, 0.7);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-9.3, 7.0, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 9.3, 7.0, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 9.3,-7.0, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-9.3,-7.0, 0.0);
		glEnd();

		glLoadIdentity();
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		BINDTEX(4);
		if(rut/333 > 145.5) {
			mov = (-145.5)+rut/333;
		}
		glTranslatef(1.6+mov+sin(rut/500)*0.5,1.2+sin(rut/600)*0.5,-4.0+sin(rut/200));
		glRotatef(rut/10, 0.5, 0.2, 0.6);
		glColor3f(0.6, 0.1, 0.3);
		harmo2((double)40);

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();
		glEnable(GL_TEXTURE_2D);
		glTranslatef(2.0, -2.0, -4.0);
		glEnable(GL_DEPTH_TEST);
		BINDTEX(21);
		glColor3f(1.0, 1.0, 1.0);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-0.5, 0.2, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 0.5, 0.2, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 0.5,-0.2, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-0.5,-0.2, 0.0);
		glEnd();
		
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND);
		glLoadIdentity();
		glTranslatef(sin(rut/750)*2.6, sin(rut/800)*2.5, -4.0);
		glRotatef(rut/10, 0.5, 0.2, 0.7);
		glScalef(0.4, 0.4, 0.4);
		harmo((float)30);

		glLoadIdentity();
		glTranslatef(0.0, 0.0, -8.0);
		BINDTEX(18);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-7.5, 6.0, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 7.5, 6.0, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 7.5,-6.0, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-7.5,-6.0, 0.0);
		glEnd();
		

	}

		glutSwapBuffers();
}

void Timer(int value)
{
	static int frame = 0, time = 0, timebase = 0, fps;
	glutPostRedisplay();
	frame++;
	time = glutGet(GLUT_ELAPSED_TIME);
	rut = time/3;
	glutTimerFunc(0, Timer, 0);
	if(frame > 100) {
		printf("FPS: %03d\tTIME: %0.5f s\n",
					 frame*1000/(time-timebase),
					 rut/333);
		timebase = time;
		frame = 0;
	}
}

void reshape(int w, int h)
{
	/* Diving on zero si teh suck */
	if(h == 0) {
		h = 1;
	}
	glViewport(0.0, 0.0, (GLsizei)w, (GLsizei)h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective (70.0f, (GLfloat) w / (GLfloat) h, 0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);
}

void key(unsigned char key, int x, int y)
{
	if(key == 27) { /* clean up shit and exit if esc is pressed */
		ogg_quit();
		kill(pid, SIGINT);
		exit(0);
	}
}

int main(int argc, char *argv[])
{

	if(pid = fork()) {
		load_textures();
		ogg_play();
	} else {
		glutInit(&argc, argv);
		glutInitDisplayMode(GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGBA);
		glutInitWindowPosition(0, 0);
		glutCreateWindow(argv[0]);
		glutSetCursor(GLUT_CURSOR_NONE);
		init();
		load_textures();
		glutDisplayFunc(display);
		glutReshapeFunc(reshape);
		glutTimerFunc(30, Timer, 0);
		glutKeyboardFunc(key);
		glutFullScreen();

		glutMainLoop(); 
		return 0;
	}
}
